;//////////////////////////////////////////////////////////////////////////////
;//
;//  Copyright (C) Microsoft Corporation.  All Rights Reserved.
;//
;//  File:       d3dx9.inc
;//  Content:    D3DX utility library
;//
;//  Translated to .ASM by: Siekmanski	contact me at: siekmanski@home.nl
;//
;//////////////////////////////////////////////////////////////////////////////

ifndef __D3DX9_H__
__D3DX9_H__ equ 1

;// Defines
include limits.inc

D3DX_DEFAULT		equ -1
D3DX_DEFAULT_NONPOW2	equ -2
D3DX_DEFAULT_FLOAT	equ FLT_MAX

;// Includes
include d3d9.inc
include d3dx9math.inc
include d3dx9core.inc
include d3dx9mesh.inc
include d3dx9tex.inc
include d3dx9shader.inc
include d3dx9effect.inc
include d3dx9shape.inc
include d3dx9anim.inc

;// Errors
_FACDD equ 0876h
MAKE_DDHRESULT MACRO code:REQ
	EXITM %((1 shl 31) or ((_FACDD and 0fffh) shl 16) or (code and 0ffffh))
ENDM

D3DXERR_CANNOTMODIFYINDEXBUFFER	TEXTEQU MAKE_DDHRESULT(2900)
D3DXERR_INVALIDMESH		TEXTEQU MAKE_DDHRESULT(2901)
D3DXERR_CANNOTATTRSORT		TEXTEQU MAKE_DDHRESULT(2902)
D3DXERR_SKINNINGNOTSUPPORTED	TEXTEQU MAKE_DDHRESULT(2903)
D3DXERR_TOOMANYINFLUENCES	TEXTEQU MAKE_DDHRESULT(2904)
D3DXERR_INVALIDDATA		TEXTEQU MAKE_DDHRESULT(2905)
D3DXERR_LOADEDMESHASNODATA	TEXTEQU MAKE_DDHRESULT(2906)
D3DXERR_DUPLICATENAMEDFRAGMENT	TEXTEQU MAKE_DDHRESULT(2907)

endif ;//__D3DX9_H__