;//////////////////////////////////////////////////////////////////////////////
;//
;//  Copyright (C) Microsoft Corporation.  All Rights Reserved.
;//
;//  File:       d3dx9math.inl
;//  Content:    D3DX math inline functions
;//
;//////////////////////////////////////////////////////////////////////////////

ifndef __D3DX9MATH_INL__
__D3DX9MATH_INL__ equ 1

;//--------------------------
;// 3D Vector
;//--------------------------


D3DXVec3Length MACRO Vector:REQ
LOCAL temp
        .data
           temp dd 0
        .code
	fld	dword ptr [Vector]
	fld	dword ptr [Vector + 4]
	fld	dword ptr [Vector + 8]
	fmul	st,st
	fld	st(1)
	fmulp	st(2),st
	faddp	st(1),st
	fld	st(1)
	fmulp	st(2),st
	faddp	st(1),st
	fsqrt
	fstp	dword ptr [temp]
	EXITM	<temp>
;	mov	eax,dword ptr [temp]
 ENDM

D3DXVec3Dot MACRO Vector1:REQ,Vector2:REQ
LOCAL temp
        .data
           temp dd 0
        .code
	fld	dword ptr [Vector1]
	fmul	dword ptr [Vector2]
	fld	dword ptr [Vector1 + 4]
	fmul	dword ptr [Vector2 + 4]
	faddp	st(1),st
	fld	dword ptr [Vector1 + 8]
	fmul	dword ptr [Vector2 + 8]
	faddp	st(1),st
	fstp	dword ptr [temp]
	EXITM	<temp>
;	mov	eax,dword ptr [temp]
ENDM


D3DXVec3Cross MACRO Vector:REQ,Vector1:REQ,Vector2:REQ
	fld	dword ptr [Vector1 + 4]
	fmul	dword ptr [Vector2 + 8]
	fld	dword ptr [Vector1 + 8]
	fmul	dword ptr [Vector2 + 4]
	fxch
	fsub	st(0),st(1)
	fstp	dword ptr [Vector]

	fld	dword ptr [Vector1 + 8]
	fmul	dword ptr [Vector2]
	fld	dword ptr [Vector1]
	fmul	dword ptr [Vector2 + 8]
	fxch
	fsub	st(0),st(1)
	fstp	dword ptr [Vector + 4]

	fld	dword ptr [Vector1]
	fmul	dword ptr [Vector2 + 8]
	fld	dword ptr [Vector1 + 8]
	fmul	dword ptr [Vector2]
	fxch
	fsub	st(0),st(1)
	fstp	dword ptr  [Vector + 8]

	fcompp
	fstp	st(0)
ENDM

;//--------------------------
;// 4D Matrix
;//--------------------------


D3DXMatrixIdentity MACRO PMatrix:REQ
	mov	dword ptr [PMatrix +  0],3f800000h
	mov	dword ptr [PMatrix +  4],0
	mov	dword ptr [PMatrix +  8],0
	mov	dword ptr [PMatrix + 12],0
	mov	dword ptr [PMatrix + 16],0
	mov	dword ptr [PMatrix + 20],3f800000h
	mov	dword ptr [PMatrix + 24],0
	mov	dword ptr [PMatrix + 28],0
	mov	dword ptr [PMatrix + 32],0
	mov	dword ptr [PMatrix + 36],0
	mov	dword ptr [PMatrix + 40],3f800000h
	mov	dword ptr [PMatrix + 44],0
	mov	dword ptr [PMatrix + 48],0
	mov	dword ptr [PMatrix + 52],0
	mov	dword ptr [PMatrix + 56],0
	mov	dword ptr [PMatrix + 60],3f800000h
ENDM


endif	;// __D3DX9MATH_INL__

